﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlexGridCellFactorySample
{
    public class Customer
    {
        public bool Premium { get; set; }
        public string Name { get; set; }
        public int Age { get; set; }
        public string Gender { get; set; }
        public double Salary { get; set; }
        public string CurrentCulture { get; set; } = System.Globalization.CultureInfo.CurrentCulture.Name;
        public DateTime RegistrationDate { get; set; }
    }

    class CustomerGenerator
    {
        static Random random = new Random();

        public static ObservableCollection<Customer> GenerateCustomers(int count)
        {
            ObservableCollection<Customer> customers = new ObservableCollection<Customer>();
            for (int index = 0; index < count; index++)
            {
                customers.Add(new Customer { Premium = IsPremiumCustomer(), Name = RandomString(7), Age = random.Next(18, 90), Salary=random.Next(2000, 10000) * random.NextDouble(), RegistrationDate = DateTime.Now + TimeSpan.FromDays(random.Next(1, 10)), Gender = RandomGender() });
            }

            return customers;
        }

        private static string RandomGender()
        {
            string[] genders = new string[] { "Male", "Female", "Others" };
            int randomNumber = random.Next(0, 2);
            return genders[randomNumber];
        }

        private static bool IsPremiumCustomer()
        {
            int randomNumber = random.Next(0, 2);
            return (randomNumber == 1) ? true : false;
        }

        private static string RandomString(int size)
        {
            StringBuilder builder = new StringBuilder();
            string alphabets = "abcdefghijklmnopqrstuvwxyz";

            for (int index = 0; index < size; index++)
            {
                builder.Append(alphabets[random.Next(0, 25)]);
            }
            return builder.ToString();
        }
    }
}
